/*

Obd Protocol Translator Integrated Chip v0.1.0.0
2005-2007 www.obdchip.com

Car Communication Routines

*/

#include <pic.h>
#include "carcom.h"
#include "delay.h"
#include "pccom.h"
#include "global.h"


void CARputch(char c)
{
	unsigned char	dly,bitno;
	CARTxData = 1;
#ifdef __PIC16F62XA_H 	//code for 16F648A
	OBD_TX_led = 1;
#endif
#ifdef __PIC16F688_H 	//code for 16F688
	OBD_TX_led = 0;
#endif

	bitno = 8;
	dly = CAR_DELAY(TX_OHEAD);	// wait one bit time
	do
	{
	}
	while (--dly);
	fb_test();
	if (bus==FB_ERROR)
		return;
	do
	{
		if (c & 1)
		{
			CARTxData = 0;
		}
		if (!(c & 1))
		{
			CARTxData = 1;
		}
		c = (c >> 1) | 0x80;
		dly = CAR_DELAY(TX_OHEAD);	// wait one bit time
		do
		{
		}
		while (--dly);
		fb_test();
		if (bus==FB_ERROR)
			return;
	}
	while (--bitno);
	CARTxData = 0;
	dly = CAR_DELAY(TX_OHEAD);	// wait one bit time
	do
	{
	}
	while (--dly);
#ifdef __PIC16F62XA_H 	//code for 16F648A
	OBD_TX_led = 0;
#endif
#ifdef __PIC16F688_H 	//code for 16F688
	OBD_TX_led = 1;
#endif
}

void CARsend(const char* s)
{
	while (*s)
		CARputch(*s++);
}


char CARgetch(void)//unsigned char* timeout)
{
	unsigned char	c, bitno,dly,cto = 0;
	unsigned long int toc = 0;
	for (; ;)
	{

		do
		{
			toc++;			
			if (toc > timeout_set) //TIMEOUT ~ 400ms 117500
			{
				cto = 1;
				break;
			}
			continue;
		}
#ifdef __PIC16F62XA_H 	//code for 16F648A
		while (CARRxData);
#endif

#ifdef __PIC16F688_H	//code for 16F648A
		while (!CARRxData);
#endif

		if (cto)
		{
			timeout = 1;
			return(0);
		}
		dly = CAR_DELAY(3) / 2;
		do
			;	// waiting in delay loop
		while (--dly);
		
#ifdef __PIC16F62XA_H 	//code for 16F648A
		if (CARRxData)
#endif
#ifdef __PIC16F688_H 	//code for 16F688
		if (!CARRxData)
#endif
			continue;	// twas just noise
		bitno = 8;
		c = 0;
#ifdef __PIC16F62XA_H 	//code for 16F648A
	OBD_RX_led = 1;
#endif
#ifdef __PIC16F688_H 	//code for 16F688
	OBD_RX_led = 0;
#endif
		do
		{
			dly = CAR_DELAY(RX_OHEAD);
			do
				;// waiting in delay loop
			while (--dly);
#ifdef __PIC16F62XA_H 	//code for 16F648A
			c = (c >> 1) | (CARRxData << 7);
#endif
#ifdef __PIC16F688_H 	//code for 16F688
			c = (c >> 1) | (!CARRxData << 7);
#endif
		}
		while (--bitno);
		timeout = 0;
		dly = CAR_DELAY(RX_OHEAD)/2;
		do
		;// waiting in delay loop
		while (--dly);

#ifdef __PIC16F62XA_H 	//code for 16F648A
	OBD_RX_led = 0;
#endif
#ifdef __PIC16F688_H 	//code for 16F688
	OBD_RX_led = 1;
#endif
	return c;
	}
}

void fb_test(void)
{
#ifdef __PIC16F62XA_H 	//code for 16F648A
	if (CARTxData==CARRxData)
#endif
#ifdef __PIC16F688_H 	//code for 16F688
	if (CARTxData!=CARRxData)
#endif
	{
		bus=FB_ERROR;
		PCsend("FB ERROR");
		CARTxData=0;
	}
	else bus=BUS_OK;
}

void CARputch_isr(char c)
{
	unsigned char	dly,bitno;
	CARTxData = 1;
#ifdef __PIC16F62XA_H 	//code for 16F648A
	OBD_TX_led = 1;
#endif
#ifdef __PIC16F688_H 	//code for 16F688
	OBD_TX_led = 0;
#endif
	bitno = 8;
	dly = CAR_DELAY(TX_OHEAD);	// wait one bit time
	do
	{
	}
	while (--dly);
	do
	{
		if (c & 1)
		{
			CARTxData = 0;
		}
		if (!(c & 1))
		{
			CARTxData = 1;
		}
		c = (c >> 1) | 0x80;
		dly = CAR_DELAY(TX_OHEAD);	// wait one bit time
		do
		{
		}
		while (--dly);
	}
	while (--bitno);
	CARTxData = 0;
	dly = CAR_DELAY(TX_OHEAD);	// wait one bit time
	do
	{
	}
	while (--dly);
#ifdef __PIC16F62XA_H 	//code for 16F648A
	OBD_TX_led = 0;
#endif
#ifdef __PIC16F688_H 	//code for 16F688
	OBD_TX_led = 1;
#endif
} 

#ifdef __PIC16F688_H 	//code for 16F688
void monitor_stop(void)
{
	if (PCRxData) 	monitor = 0;	
}	
#endif	

#ifdef __PIC16F62XA_H 	//code for 16F648A
void monitor_stop(void)
{
	if (!PCRxData) 	monitor = 0;	
}	
#endif	
	
char CARgetch_x(void)
{
	unsigned char	c, bitno,dly;
	for (; ;)
	{
		while (CARRxData)//nu uita
		{
			monitor_stop();
			if (!monitor)
				return 0;
			continue;
		}
		dly = CAR_DELAY(3) / 2;
		do
			;	// waiting in delay loop
		while (--dly);
		if (CARRxData)
			continue;	// twas just noise
		bitno = 8;
		c = 0;
		OBD_RX_led=1;
		do
		{
			dly = CAR_DELAY(RX_OHEAD);
			do
				;// waiting in delay loop
			while (--dly);
			c = (c >> 1) | (CARRxData << 7);
		}

		while (--bitno);
		monitor_stop();
		dly = CAR_DELAY(RX_OHEAD)/2;
		do
		;// waiting in delay loop
		while (--dly);

		OBD_RX_led=0;
		monitor_stop();
		return c;
	}
}
	
//#endif

