/*

Obd Protocol Translator Integrated Chip v0.1.0.0
2005-2007 www.obdchip.com

Car Communication Header

*/

#include "constants.h"
/*	Baud rate	*/
#define CAR_BRATE 10400

/*	Don't change anything else */
#define	DLY		3		/* cycles per null loop */
#define	TX_OHEAD	13		/* overhead cycles per loop */
#define	RX_OHEAD	12		/* receiver overhead per loop */

#define	CAR_DELAY(ohead)	(((PIC_CLK/4/CAR_BRATE)-(ohead))/DLY)

/*	Transmit and Receive port bits */
#define PORTBIT(adr, bit) ((unsigned)(&adr)*8+(bit))

#ifdef __PIC16F688_H	//cod pentru 16F688
static bit	CARTxData 			@ PORTBIT(PORTA, 0);
static bit	CARRxData 			@ PORTBIT(PORTA, 2);
static bit	CAR_L 				@ PORTBIT(PORTA, 1);
static bit	OBD_TX_led 			@ PORTBIT(PORTC, 0);
static bit	OBD_RX_led 			@ PORTBIT(PORTC, 1);

static bit	TRIS_CARTxData 		@ PORTBIT(TRISA, 0);
static bit	TRIS_CARRxData 		@ PORTBIT(TRISA, 2);
static bit	TRIS_CAR_L 			@ PORTBIT(TRISA, 1);
static bit	TRIS_OBD_TX_led 	@ PORTBIT(TRISC, 0);
static bit	TRIS_OBD_RX_led 	@ PORTBIT(TRISC, 1);
#endif

#ifdef __PIC16F62XA_H  //cod pentru 16F648A
static bit	TRIS_CARTxData 		@ PORTBIT(TRISA, 0);
static bit	TRIS_CARRxData 		@ PORTBIT(TRISA, 1);
static bit	TRIS_CAR_L 			@ PORTBIT(TRISA, 2);
static bit	TRIS_OBD_RX_led 	@ PORTBIT(TRISB, 5);
static bit	TRIS_OBD_TX_led 	@ PORTBIT(TRISB, 4);

static bit	CARTxData 			@ PORTBIT(PORTA, 0);
static bit	CARRxData 			@ PORTBIT(PORTA, 1);
static bit	CAR_L 				@ PORTBIT(PORTA, 2);
static bit	OBD_RX_led 			@ PORTBIT(PORTB, 5);
static bit	OBD_TX_led 			@ PORTBIT(PORTB, 4);

#endif//*/

void CARputch(char c);
char CARgetch(void);
void SendAt5Bps(char c);
void CARsend(const char* s);
void CARputch_isr(char c);
void fb_test(void);
char bus_test(void);
void monitor_stop(void);
char CARgetch_x(void);
