/*

Obd Protocol Translator Integrated Chip v0.1.0.0
2005-2007 www.obdchip.com

Constants Header

*/

#ifdef __PIC16F62XA_H
  #define __PIC16F648A
#endif
#ifdef __PIC16F688_H
  #define __PIC16F688
#endif

//*****************************************************************************
//  						 GENERAL CONFIGURATION
//*****************************************************************************

#define PIC_CLK 				20000000  		// PIC CLOCK IN HZ
#define TIME_OUT 				30000  			// TIME TO WAIT VEHICLE RESPONSE
#ifdef __PIC16F62XA_H 	//code for 16F648A
	#define CHIP_ID 				"OIC504 v2.0"	// CHIP ID
	#define EXTENDED_ID				"ObdChip OIC504 real version 1.0.0 2005-2007 www.obdchip.com"
#endif
#ifdef __PIC16F688_H 	//code for 16F688
	#define CHIP_ID 				"OIC503 v2.0"	// CHIP ID
	#define EXTENDED_ID				"ObdChip OIC503 real version 1.0.0 2005-2007 www.obdchip.com"
#endif
#define CR_NOTICE				"Free for personal use."
#define WEB_NOTICE			"www.obdchip.com"
//*****************************************************************************
//  				      COMMUNICATION CONFIGURATION
//*****************************************************************************
#define PC_BRATE				9600  			//PC BAUD RATE IN BPS 
#define CAR_BRATE 				10400			//CAR BAUD RATE IN BPS

//*****************************************************************************
//  						 DELAYS AND TIMEOUTS
//*****************************************************************************
#define KW2_DELAY				25  			// ms
#define FIRST_REQUEST_DELAY		20  			// ms


//*****************************************************************************
//  					  	 INTERNAL CONSTANTS
//*****************************************************************************
#define ISO9141 				1
#define ISO14230 				0

#define INIT_ERROR				10

#define FB_ERROR 				3
#define BUS_OK					5
#define BUS_BUSY				4

#define DATA_OK 				1
#define DATA_ERROR 				2
#define NO_DATA 				0
#define OK						1

#define PACKED					1
#define FORMATTED 				0	


