/*

   Obd Protocol Translator Integrated Chip v0.1.0.0
   2005-2007 www.obdchip.com

   Main Program

 */


#include <pic.h>
#include <ctype.h>

#ifdef __PIC16F688_H    //code for 16F688

__CONFIG(WDTDIS& PWRTEN& HS& PROTECT& BORDIS& MCLRDIS);
#endif

#ifdef __PIC16F62XA_H   //code for 16F648A
//__CONFIG(WDTDIS& PWRTEN& HS&  BORDIS& LVPDIS& MCLRDIS);

__CONFIG(WDTDIS& PWRTEN& HS& PROTECT& BORDIS& LVPDIS& MCLRDIS& CPD);
#endif

#include "constants.h"
#include "pccom.h"
#include "carcom.h"
#include "delay.h"
#include "global.h"



bit mr,mr_set=0, ar_mode,mr_set_auto, atsh,diag_mode=ISO14230, csc_ok = 0, tgtc_ok = 0,enter=0,
    CarInit = 0, IsHEX = 0, header=0, line_feed, echo,initializare;
unsigned char i, j, k, bi,u;

unsigned bank1 char cs, src = 0xF1, tgt = 0x33, tgt_temp, fmt, fmtm = 0xC0, kw1, kw2, SR_address,
                    keepalive=25;
unsigned bank1 char a, s[35], c1, c2, lr;
unsigned char p[20];


unsigned bank1 char e,counter; //isr
bank1 char Table1[5]={0xC1,0x33,0xf1,0x3e,0x23};        //keepalive request
bank1 char Table3[6]={0x68,0x6a,0xf1,0x01,0x00,0xc4};   //keepalive ok response



void keep_alive(unsigned char set)
{

	if (set==0)
	{
		TMR1IE=0;
		PEIE=0;
		GIE=0;
		counter=0;
	}
	else
	{
		TMR1H=0;
		TMR1L=0;
		TMR1IE=1;
		PEIE=1;
		GIE=1;
		counter=0;
	}

}

static void interrupt isr(void)
{

	if (TMR1IF==1)
	{
		counter++;
		if (counter==keepalive)         //131 ms * counter keep_alive
		{
			//Go away I'm keep aliving

			counter=0;

			if (diag_mode==ISO9141)
				for (e=0; e<6; e++)
				{
					CARputch_isr(Table3[e]);
				}
			else
				for (e=0; e<5; e++)
				{
					CARputch_isr(Table1[e]);
				}
			DelayUs(50);

		}
		TMR1IF=0;
	}
}



//*****************************************************************************
//  						 Command for car
//*****************************************************************************
void bus_busy(void)
{
	unsigned long int timeout_set_temp;

	timeout_set_temp=timeout_set;
	timeout_set=5000;
	a=CARgetch();
	timeout_set=timeout_set_temp;
	if (timeout)
		bus=BUS_OK;
	else
	{
		bus=BUS_BUSY;
		PCsend("BUS BUSY");
	}
}

void send_hex(unsigned char length) // formateaza si trimite sirul "s"
{
	if (diag_mode==ISO9141)
		fmt=fmtm;
	else
		fmt = (length | (fmtm & 0xc0)); //format byte
	j=length;

	do
	{
		j--;
		s[j+3]=s[j];
	}
	while (j!=0);
	s[0]=fmt; //format
	s[1]=tgt; //target
	s[2]=src; //source
	cs = 0;
	for (j = 0; j < length+3; j++) cs = cs + (s[j] & 255);
	s[length+3]=cs;
	if (!initializare)
		bus_busy();
	else
		bus==BUS_OK;
	if (bus==BUS_OK)
	{
		for (j = 0; j < length+4; j++)
		{
			CARputch(s[j]);
			if (bus==FB_ERROR)
				return;
		}
	}
}


unsigned char get_hex(void)
{
	unsigned long int timeout_set_temp;
	//DelayMs(10);
	a = CARgetch();
	if (timeout)         //timeout
	{
		return(NO_DATA);
	}
	if (diag_mode==ISO9141)
	{
		lr=20;
		timeout_set_temp=timeout_set;
		timeout_set=1500;
	}
	else
		lr = (a & 0b00111111)+3;
	if (lr>20) lr=20;
	s[0] = a;
	if (a!=0)
	{
		for (j = 1; j <= lr; j++)         //reading car response
		{
			s[j] = CARgetch();
			if (timeout)
			{
				if (diag_mode==ISO9141)
				{
					lr = j-1;
					timeout_set = timeout_set_temp;
				}
				else
					return(DATA_ERROR);
			}
		}
	}
	else
	if (diag_mode==ISO9141)
	{
		timeout_set=timeout_set_temp;
	}

//CS is ok?
	cs = 0;
	for (j = 0; j < lr; j++)
	{
		cs = cs + (s[j] & 255);
	}
	csc_ok=(cs==s[lr]);
//Response is for me?
	if (ar_mode)
	{
		if (diag_mode==ISO9141)
			tgtc_ok=(s[1]==(tgt+1));
		else
			tgtc_ok=(s[1]==src);
	}
	else
		tgtc_ok=(s[1]==SR_address);
//Sending string to computer or printing error message
	if (tgtc_ok)
	{
		if (csc_ok)
		{
			return DATA_OK;
		}
		else return DATA_ERROR;
	}
	return NO_DATA;
}

//*****************************************************************************
//  				DiagMode
//*****************************************************************************

void Diag_Mode(void)
{
	if (atsh==0)
	{
		if (diag_mode==ISO9141)
		{
			fmtm=0x68;
			tgt=0x6a;
		}
		else
		{
			fmtm=0xc0;
			tgt=0x33;
		}

	}
}

//*****************************************************************************
//  						 Bus init
//*****************************************************************************

void bus_init(void)
{

	PCsend("BUS INIT: ");
	bus_busy();
}
//*****************************************************************************
//  					SlowInit
//*****************************************************************************


void SendAt5Bps(char c)
{
	unsigned char bitno;
#ifdef __PIC16F62XA_H   //code for 16F648A
	OBD_TX_led = 1;
#endif
#ifdef __PIC16F688_H    //code for 16F688
	OBD_TX_led = 0;
#endif
	CARTxData = 1;
	CAR_L = 1;
	DelayMs(200);
	fb_test();
	if (bus==FB_ERROR)
		return;
	bitno = 8;
	PCputch('.');
	do
	{
		if (bitno==4) PCputch('.');

		if (c & 1)
		{
			CARTxData = 0;
			CAR_L = 0;
		}
		if (!(c & 1))
		{
			CAR_L = 1;
			CARTxData = 1;
		}
		c = (c >> 1) | 0x80;
		DelayMs(200);
		fb_test();
		if (bus==FB_ERROR)
			return;
	}
	while (--bitno);
	PCputch('.');
	CARTxData = 0;
	CAR_L = 0;
	DelayMs(200);
#ifdef __PIC16F62XA_H   //code for 16F648A
	OBD_TX_led = 0;
#endif
#ifdef __PIC16F688_H    //code for 16F688
	OBD_TX_led = 1;
#endif
}


void SlowInit(void)
{
	if (bus==BUS_OK)
	{
		SendAt5Bps(tgt);
		if (bus==BUS_OK)
		{
			s[0] = CARgetch();
			if (timeout)
				i=INIT_ERROR;
			else
			{
				if (s[0] != 0x55)
					i=INIT_ERROR;
				else
				{
					s[1] = CARgetch();
					if (timeout)
						i=INIT_ERROR;
					else
					{
						s[2] = CARgetch();
						if (timeout)
							i=INIT_ERROR;
						else
						{
							DelayMs(KW2_DELAY);
							CARputch(~s[2]);
							s[3] = CARgetch();
							if (timeout)
								i=INIT_ERROR;
							else
							{
								kw1=s[1];
								kw2=s[2];
								if((unsigned char)(s[3] + tgt)!= 0xff)
									i=INIT_ERROR;
								else
								{
									if (kw2==0x08) diag_mode=ISO9141;
									else if (kw2==0x94) diag_mode=ISO9141;
									else diag_mode=ISO14230;;
									DelayMs(FIRST_REQUEST_DELAY);
									PCsend("OK");
									CarInit = 1;
									keep_alive(1);
									Diag_Mode();
									i=OK;
								}
							}
						}
					}
				}
			}
		}

	}
}

//*****************************************************************************
//  						 FastInit
//*****************************************************************************

void FastInit(void)
{
	if (bus==BUS_OK)
	{
		diag_mode=ISO14230;
		Diag_Mode();
		s[0]=0x81;

		CARTxData = 0;
		CAR_L = 0;
		DelayBigMs(300);


		fb_test();
		if (bus==FB_ERROR)
			return;


		CARTxData = 1;
		CAR_L = 1;
		DelayMs(25);

		fb_test();
		if (bus==FB_ERROR)
			return;

		CARTxData = 0;
		CAR_L = 0;
		DelayMs(25);

		fb_test();
		if (bus==FB_ERROR)
			return;

		initializare=1;
		send_hex(1);
		initializare=0;
		if (bus==BUS_OK)
		{
			i=get_hex();
			if (i==1)                               //response is for me
			{
				if (s[3]==0xc1)
				{
					CarInit=1;
					keep_alive(1);
					PCsend("OK");
					kw1=s[4];
					kw2=s[5];
					DelayMs(FIRST_REQUEST_DELAY);
				}
				else i=INIT_ERROR;
			}
			else i=INIT_ERROR;
		}
	}
}
//*****************************************************************************
//  						 INIT
//*****************************************************************************

void init(void)
{
	bus_init();
	if (bus==BUS_OK)
	{
		SlowInit();
		if (bus!=FB_ERROR)
			if (!CarInit)
			{
				bus=BUS_OK;
				FastInit();

				if (i==INIT_ERROR)
					PCsend("ERROR");
			}
	}
	if (CarInit)
	{
		PCputch(0x0D);
		if (line_feed)
			PCputch(0x0A);
	}
}
//*****************************************************************************
//  						 IS hex
//*****************************************************************************


void is_hex(void)
{

	IsHEX = 1;
	if (!enter)
	{
		for (j = 0; j < i; j = j + 2)                 //verify if everything is hex
		{
			if ((((p[j] >= 48) && (p[j] <= 57)) ||
			     ((p[j] >= 65) && (p[j] <= 70))) &&
			    (((p[j + 1] >= 48) && (p[j + 1] <= 57)) ||
			     ((p[j + 1] >= 65) && (p[j + 1] <= 70))))
			{
				if (p[j] > 64)
					c1 = p[j] - 55;
				else
					c1 = p[j] - 48;
				if (p[j + 1] > 64)
					c2 = p[j + 1] - 55;
				else
					c2 = p[j + 1] - 48;
				p[bi] = 16 * c1 + c2;
				bi++;                 //string length
			}
			else
				IsHEX = 0;
		}
	}
	enter=0;
	if (IsHEX)
	{
		if (!CarInit)
		{
			init();
		}
		if (CarInit)
		{
			keep_alive(0);
			DelayMs(5);
			if (mr_set==0)
			{
				if((p[0]==0x01)&&(p[1]==0x01)&&(bi==2))
				{
					mr_set=1;
					mr_set_auto=1;
				}
				else if ((p[0]==0x03)&&(bi==1))
				{
					mr_set=1;
					mr_set_auto=1;
				}
				else if ((p[0]==0x04)&&(bi==1))
				{
					mr_set=1;
					mr_set_auto=1;
				}
			}
			for (i=0; i<bi; i++)
				s[i]=p[i];
			send_hex(bi);
			//waiting for car response
			if (bus==BUS_OK)
			{
				do
				{
					i=get_hex();
					if (i)
					{
						if ((mr)&&(data_style!=PACKED))
						{
							PCputch(0x0D);
							if (line_feed)
								PCputch(0x0A);
						}

						if (header)
						{
							for (j = 0; j <= lr; j++)                 //sending to computer
							{
								PCputcha(s[j]);
								PCputch(' ');
							}
							if (i==DATA_ERROR) PCsend("<DATA ERROR");
						}
						else
						{
							if (data_style==PACKED)
							{
								if (lr>3)
									lr=lr-3;
								else (lr=0);
								lr=lr-3;
								if (i==DATA_ERROR)
									PCputch(lr|0x80);
								else
									PCputch(lr);
								for (j = 0; j < lr; j++)                         //sending to computer
								{
									PCputch(s[j+3]);
								}
							}
							else if (data_style==FORMATTED)
							{
								for (j = 3; j < lr; j++)                 ///sending to computer
								{
									PCputcha(s[j]);
									PCputch(' ');
								}
								if (i==DATA_ERROR) PCsend("<DATA ERROR");
							}
						}
						if (mr_set)
							mr=1;
						else mr=0;

					}

					if (!i)
					{
						if (mr==0)
						{

							if (data_style==PACKED)
							{
								PCputch(0x00);
							}
							else if (data_style==FORMATTED)
							{
								PCsend("NO DATA");
							}
						}
					}
					if (!mr_set)
						i=0;
				}
				while(i!=0);
			}
			keep_alive(1);
			mr=0;
			if (mr_set_auto)
			{
				mr_set_auto=0;
				mr_set=0;
			}
		}
	}
	else                 //nu e hex
	{
		PCsend("?");
	}
	cr(line_feed);


}


//*****************************************************************************
//  						 AT commands
//*****************************************************************************



void ATcommand(void)
{
	unsigned char temp1;
	unsigned long int temp2;
	unsigned long int timeout_set_temp;
	enter=0;
	switch (p[2])
	{
	case 'A':
	{
		if (p[3]=='R')                        //ATAR
		{
			ar_mode=1;
			PCsend("OK");
		}
		else
		{
			PCputch('?');
		}

		cr(line_feed);
		break;
	}


	case 'B':
	{
		if (p[3]=='D')                              // ATBD DUMP BUFFER
			for (i=0; i<35; i++)
			{
				PCputcha(s[i]);
				PCputch(' ');
			}
		else if (p[3]=='C')                                     // ATBC CLEAR BUFFER
			for (i=0; i<35; i++)
			{
				s[i]=0x00;
			}
		else
		{
			PCputch('?');
		}

		cr(line_feed);
		break;
	}
	case 'S':
	{
		if (p[3]=='P')                        // ATSP
		{
			PCsend("ATSH ");
			if (atsh)
			{
				PCputcha(fmtm);
				PCputch(' ');
				PCputcha(tgt);
				PCputch(' ');
				PCputcha(src);
			}
			else
				PCsend("AUTO");
			cr(line_feed);
			break;
		}

		if (p[3]=='T')                        // ATST
		{
			if ((((p[4] >= 48) && (p[4] <= 87)) ||
			     ((p[4] >= 65) && (p[4] <= 70))) &&
			    (((p[5] >= 48) && (p[5] <= 87)) ||
			     ((p[5] >= 65) && (p[5] <= 70))))
			{
				if (p[4] > 64)
					c1 = p[4] - 55;
				else
					c1 = p[4] - 48;
				if (p[5] > 64)
					c2 = p[5] - 55;
				else
					c2 = p[5] - 48;
				temp1=(16 * c1+ c2);
				if (temp1==0)
					timeout_set==30000;
				else
				{
					temp2=temp1*0x58;
					timeout_set=temp2;
					temp2=temp1*0x02;
					temp2=temp2<<8;
					timeout_set+=temp2;
				}
				//600=0x0258
				PCsend("OK ");


			}
			else
			{
				PCputch('?');
			}

			cr(line_feed);
			break;
		}


		if (p[3]=='W')                        // ATSW
		{
			if ((((p[4] >= 48) && (p[4] <= 87)) ||
			     ((p[4] >= 65) && (p[4] <= 70))) &&
			    (((p[5] >= 48) && (p[5] <= 87)) ||
			     ((p[5] >= 65) && (p[5] <= 70))))
			{
				if (p[4] > 64)
					c1 = p[4] - 55;
				else
					c1 = p[4] - 48;
				if (p[5] > 64)
					c2 = p[5] - 55;
				else
					c2 = p[5] - 48;
				if ((16 * c1 + c2)==0) ;
				else if ((16 * c1 + c2)>5)
				{
					keepalive = (unsigned char)((16 * c1 + c2)/5);
				}
				else
					keepalive =1;
				PCsend("OK");

			}
			else
			{
				PCputch('?');
			}

			cr(line_feed);
			break;
		}

		if (p[3]=='R')                        // ATSR
		{
			if ((((p[4] >= 48) && (p[4] <= 87)) ||
			     ((p[4] >= 65) && (p[4] <= 70))) &&
			    (((p[5] >= 48) && (p[5] <= 87)) ||
			     ((p[5] >= 65) && (p[5] <= 70))))
			{
				if (p[4] > 64)
					c1 = p[4] - 55;
				else
					c1 = p[4] - 48;
				if (p[5] > 64)
					c2 = p[5] - 55;
				else
					c2 = p[5] - 48;
				SR_address = 16 * c1 + c2;
				ar_mode=0;
				PCsend("OK");

			}
			else
			{
				PCputch('?');
			}

			cr(line_feed);
			break;
		}
		if (p[3]=='H')                        // ATSH
		{
			p[4] = toupper(p[4]);                         //fmt
			p[5] = toupper(p[5]);
			if ((((p[4] >= 48) && (p[4] <= 87)) ||
			     ((p[4] >= 65) && (p[4] <= 70))) &&
			    (((p[5] >= 48) && (p[5] <= 87)) ||
			     ((p[5] >= 65) && (p[5] <= 70))))
			{
				if (p[4] > 64)
					c1 = p[4] - 55;
				else
					c1 = p[4] - 48;
				if (p[5] > 64)
					c2 = p[5] - 55;
				else
					c2 = p[5] - 48;

				fmtm = 16 * c1 + c2;
				if (!CarInit)
				{
					Table1[0]=((fmtm&0xc0)+1);
					Table3[0]=(fmtm);
				}
			}
			else
			{
				PCputch('?');
				cr(line_feed);
				break;
			}

			p[6] = toupper(p[6]);                         //tgt
			p[7] = toupper(p[7]);
			if ((((p[6] >= 48) && (p[6] <= 87)) ||
			     ((p[6] >= 65) && (p[6] <= 70))) &&
			    (((p[7] >= 48) && (p[7] <= 87)) ||
			     ((p[7] >= 65) && (p[7] <= 70))))
			{
				if (p[6] > 64)
					c1 = p[6] - 55;
				else
					c1 = p[6] - 48;
				if (p[7] > 64)
					c2 = p[7] - 55;
				else
					c2 = p[7] - 48;
				tgt = 16 * c1 + c2;
				if (!CarInit)
				{
					Table1[1]=tgt;
					Table3[1]=tgt;
				}
			}
			else
			{
				PCputch('?');
				cr(line_feed);
				break;
			}

			p[8] = toupper(p[8]);
			p[9] = toupper(p[9]);
			if ((((p[8] >= 48) && (p[8] <= 87)) ||
			     ((p[8] >= 65) && (p[8] <= 70))) &&
			    (((p[9] >= 48) && (p[9] <= 87)) ||
			     ((p[9] >= 65) && (p[9] <= 70))))
			{
				if (p[8] > 64)
					c1 = p[8] - 55;
				else
					c1 = p[8] - 48;
				if (p[9] > 64)
					c2 = p[9] - 55;
				else
					c2 = p[9] - 48;
				src = 16 * c1 + c2;
				if (!CarInit)
				{
					Table1[2]=src;
					Table3[2]=src;
				}

			}
			else
			{
				PCputch('?');
				cr(line_feed);
				break;
			}

			cs=0;
			for(e=0; e<4; e++)
			{
				cs=cs+(Table1[e]&255);
			}
			Table1[4]=cs;

			cs=0;
			for(e=0; e<5; e++)
			{
				cs=cs+(Table3[e]&255);
			}
			Table3[5]=cs;
			atsh=1;
			PCsend("OK");
			cr(line_feed);
			break;
		}
//ATSI
		if (p[3]=='I')                        // ATSI
		{
			bus_init();
			SlowInit();
			if (i==INIT_ERROR)
				PCsend("ERROR");
			cr(line_feed);
			break;
		}
		else
		{
			PCputch('?');
		}
		cr(line_feed);
		break;

	}


	case 'F':
	{
//ATFI
		if (p[3]=='I')                        // ATFI
		{
			bus_init();
			FastInit();
			if (i==INIT_ERROR)
				PCsend("ERROR");
			cr(line_feed);
			break;
		}
		if (p[3]=='D')
		{
			data_style=FORMATTED;
			PCsend("OK");
			cr(line_feed);
			break;
		}
		else
		{
			PCputch('?');
			cr(line_feed);
		}
		break;
	}

	case 'I':                // ATI
	{
		PCsend(CHIP_ID);
		cr(line_feed);
		break;
	}

	case 'O':                // ATO
	{
		PCsend(EXTENDED_ID);
		simple_cr(line_feed);
		PCsend(CR_NOTICE);
		simple_cr(line_feed);
		PCsend(WEB_NOTICE);
		cr(line_feed);
		break;
	}

	case 'P':                // ATP
	{
		if (p[3]=='D')
		{
			header=0;
			data_style=PACKED;
			PCsend("OK");
			cr(line_feed);
			break;
		}
		else
		{
			PCputch('?');
			cr(line_feed);
		}
		break;
	}

	case 'K':                // ATK
	{
		PCputcha(kw1);
		PCputcha(kw2);
		cr(line_feed);
		break;
	}
	case 'R':                // ATR
	{
		p[3] = toupper(p[3]);
		if ((p[3] == '0') || (p[3] == '1'))
		{
			mr_set = p[3] - 48;
			if (mr_set)
				mr_set_auto=0;
		}
		else
		{
			PCputch('?');
			cr(line_feed);
			break;
		}
		PCsend("OK");
		cr(line_feed);
		break;
	}

	case 'E':                // ATE
	{
		p[3] = toupper(p[3]);
		if ((p[3] == '0') || (p[3] == '1'))
			echo = p[3] - 48;
		else
		{
			PCputch('?');
			cr(line_feed);
			break;
		}
		PCsend("OK");
		cr(line_feed);
		break;
	}
	case 'H':                // ATH
	{
		p[3] = toupper(p[3]);
		if ((p[3] == '0') || (p[3] == '1'))
			header = p[3] - 48;
		else
		{
			PCputch('?');
			cr(line_feed);
			break;
		}
		if (header)
			data_style=FORMATTED;
		PCsend("OK");
		cr(line_feed);
		break;
	}

	case 'D':                // ATD
	{

		fmtm = 0xC0;
		src = 0xF1;
		tgt = 0x33;
		Table1[0]=(fmtm+1);
		Table1[1]=tgt;
		Table1[2]=src;
		Table1[4]=0x23;

		Table3[0]=0x68;
		Table3[1]=0x6a;
		Table3[2]=src;
		Table3[5]=0xc4;
		data_style=FORMATTED;
		atsh=0;
		monitor=0;
		ar_mode=1;
		echo = 1;
		header=0;
		mr_set_auto=0;
		mr_set=0;
		timeout_set=TIME_OUT;
#ifdef __PIC16F688_H    //code for 16F688
		line_feed = LF_mode;
#endif
#ifdef __PIC16F62XA_H   //code for 16F648A
		line_feed = 1;
#endif

		keepalive=25;
		PCsend("OK");
		cr(line_feed);
		break;
	}

	case 'Z':                // ATZ
	{
		keep_alive(0);
		s[0]=0x82;
		send_hex(1);
		CarInit=0;
		fmtm = 0xC0;
		src = 0xF1;
		tgt = 0x33;
		Table1[0]=(fmtm+1);
		Table1[1]=tgt;
		Table1[2]=src;
		Table1[4]=0x23;

		Table3[0]=0x68;
		Table3[1]=0x6a;
		Table3[2]=src;
		Table3[5]=0xc4;

		keepalive=25;
		timeout_set=TIME_OUT;
		data_style=FORMATTED;
		monitor=0;
		ar_mode=1;
		atsh=0;
		echo = 1;
		header=0;
		mr_set_auto=0;
		mr_set=0;
		PCputch(0x0D);
		if (line_feed) PCputch(0x0A);
		SR_address=0x00;
		for (i=0; i<20; i++)
		{
			s[i]=0x00;
		}
		for (i=0; i<20; i++)
		{
			p[i]=0x00;
		}
		u=0;

#ifdef __PIC16F688_H    //code for 16F688

		PCTxData = 1;
		CARTxData = 0;
		CAR_L = 0;

		OBD_TX_led=0;
		PC_TX_led=0;
		DelayBigMs(200);
		OBD_TX_led=1;
		PC_TX_led=1;
		DelayBigMs(20);
		OBD_RX_led=0;
		PC_RX_led=0;
		DelayBigMs(200);
		OBD_TX_led=1;
		OBD_RX_led=1;
		PC_TX_led=1;
		PC_RX_led=1;
		line_feed = LF_mode;

#endif

#ifdef __PIC16F62XA_H   //code for 16F648A

		PCTxData = 1;
		CARTxData = 0;
		CAR_L = 0;

		OBD_TX_led=1;
		OBD_RX_led=1;
		DelayBigMs(200);
		OBD_TX_led=0;
		OBD_RX_led=0;
		line_feed = 1;
#endif

		DelayBigMs(500);
		PCsend(CHIP_ID);
		cr(line_feed);
		break;
	}
	case 'L':                // ATL
	{
		p[3] = toupper(p[3]);
		if ((p[3] == '0') || (p[3] == '1'))
			line_feed = p[3] - 48;
		else
		{
			PCputch('?');
			cr(line_feed);
			break;
		}
		PCsend("OK");
		cr(line_feed);
		break;
	}
	case 'M':                // ATMA
	{
		keep_alive(0);
		monitor=1;

		do
		{
			a = CARgetch_x();
			if(monitor)
			{
				lr=20;
				timeout_set_temp=timeout_set;
				timeout_set=10000;
				s[0] = a;
				if (a!=0)
				{
					for (j = 1; j <= lr; j++)                         //reading car response
					{
						s[j] = CARgetch();
						if (timeout)
						{
							lr = j-1;
							timeout_set = timeout_set_temp;
							break;
						}
						monitor_stop();
					}
				}

				cs = 0;
				for (j = 0; j < lr; j++)
				{
					cs = cs + (s[j] & 255);
				}
				csc_ok=(cs==s[lr]);
				if (csc_ok)
				{
					i=DATA_OK;
				}
				else i=DATA_ERROR;

				if (i)
				{
					if ((mr)&&(data_style!=PACKED))
					{
						PCputch(0x0D);
						if (line_feed)
							PCputch(0x0A);
					}

					if (header)
					{
						for (j = 0; j <= lr; j++)                         //sending to computer
						{
							PCputcha(s[j]);
							PCputch(' ');
							monitor_stop();
						}
						if (i==DATA_ERROR) PCsend("<DATA ERROR");
					}
					else
					{
						if (data_style==PACKED)
						{
							if (lr>3)
								lr=lr-3;
							else (lr=0);
							if (i==DATA_ERROR)
								PCputch(lr|0x80);
							else
								PCputch(lr);
							for (j = 0; j < lr; j++)                                 //sending to computer
							{
								PCputch(s[j+3]);
								monitor_stop();
							}
						}
						else if (data_style==FORMATTED)
						{
							for (j = 3; j < lr; j++)                         //sending to computer
							{
								PCputcha(s[j]);
								PCputch(' ');
								monitor_stop();
							}
							if (i==DATA_ERROR) PCsend("<DATA ERROR");
						}
					}
					mr=1;
				}

				monitor_stop();
			}
		}
		while(monitor!=0);



		cr(line_feed);
		break;
	}

	default:
	{
		PCputch('?');
		cr(line_feed);
		break;
	}
	}
}

void format_string(void)
{
	//*****************************************************************************
	//  		 Removing chars that are not in 0-9 A-Z range
	//*****************************************************************************
	for (j = 0; j < i; j++)
	{
		if (((p[j] >= 48) && (p[j] <= 57)) | ((p[j] >= 65) && (p[j] <= 90)))
		{

			p[k] = p[j];
			k++;
		}
	}
	for (j=k; j<i; j++)
		p[j]=0x00;
	i=k;
}




void main(void)
{

	//*****************************************************************************
	//  							  Hardware config
	//*****************************************************************************
#ifdef __PIC16F688_H    //code for 16F688

//	TRISA = 0x00;
//	PORTA = 0x00;
//	TRISC = 0x00;
//	PORTC = 0x00;
	T1CON=0b00110001;       //timeout setup
	SPEN=0;
	CMCON0 = 0x07;
	ANSEL = 0x00;

	TRIS_CARTxData=0;
	TRIS_CARRxData=1;
	TRIS_CAR_L=0;
	TRIS_OBD_TX_led=0;
	TRIS_OBD_RX_led=0;
	TRIS_PCTxData=0;
	TRIS_PCRxData=1;
	TRIS_PC_TX_led=0;
	TRIS_PC_RX_led=0;
	TRIS_LF_mode=1;


	OBD_TX_led=1;
	OBD_RX_led=1;
	PC_TX_led=1;
	PC_RX_led=1;

	PCTxData = 1;
	CARTxData = 0;
	CAR_L = 0;


	OBD_TX_led=0;
	PC_TX_led=0;
	DelayBigMs(200);
	OBD_TX_led=1;
	PC_TX_led=1;
	DelayBigMs(20);
	OBD_RX_led=0;
	PC_RX_led=0;
	DelayBigMs(200);
	OBD_TX_led=1;
	OBD_RX_led=1;
	PC_TX_led=1;
	PC_RX_led=1;
	line_feed=LF_mode;


#endif

#ifdef __PIC16F62XA_H   //code for 16F648A
	TRISA = 0x00;
	CMCON = 0x07;
	TRISA = 0b00100010;
	PORTA = 0b00010000;
	TRISB = 0b00000010;
	PORTB = 0b00000000;
	T1CON = 0b00110001;     //timeout setup
	SPEN=0;

	TRIS_CARTxData=0;
	TRIS_CARRxData=1;
	TRIS_CAR_L=0;
	TRIS_PCTxData=0;
	TRIS_PCRxData=1;

	TRIS_OBD_RX_led=0;
	TRIS_OBD_TX_led=0;

	OBD_TX_led=1;
	OBD_RX_led=1;
	DelayBigMs(500);
	OBD_TX_led=0;
	OBD_RX_led=0;



	PCTxData = 1;
	CARTxData = 0;
	CAR_L = 0;

	line_feed=1;

#endif

	echo=1;
	ar_mode=1;
	CarInit = 0;
	data_style=FORMATTED;
	PCsend(CHIP_ID);
	cr(line_feed);
	src = 0xF1;
	tgt = 0x33;
	fmtm = 0xC0;
	for (; ;)
	{
		i = 0;
		k = 0;
		bi = 0;
		//*****************************************************************************
		//  Wait string from computer (cr ended) - transform lowercase to uppercase
		//*****************************************************************************

		do
		{
			a = PCgetch(echo);
			if (a==0x0d)  // do we have repeated cr? do previous command
				if(i==0)
				{
					enter=1;
					i=u;
					bi=i/2;
					break;
				}
			enter=0;
			if (a==0x08) // backspace? erase last char from buffer
			{
				if (i>0)
				{
					i--;
					p[i]=0x00;
				}
			}
			else
			{
				if ((a >= 97) && (a <= 122))  // transform lowercase to uppercase
					a = a - 32;
				p[i] = a;
				i++;
				if (i > 36)  // buffer overflow?
				{
					p[0] = 'X';      //overflow protection
					i=1;
				}
			}
		}
		while (a != 13);
		DelayUs(100);
		if ((echo)&&(line_feed))
			PCputch(0x0A);

		if (i!=0)
		{
			if (!enter)
			{
				u=i;
				i=i-1;
				p[i]=0x00; //transform cr in 0
				format_string();
			}
			if ((p[0] == 'A') && (p[1] == 'T'))
				ATcommand();
			else if (i) is_hex();
			else
			{
				PCputch('?');
				cr(line_feed);
			}

		}
		else
		{
			PCputch('?');
			cr(line_feed);
			for(i=0; i<35; i++)  //clearing buffer
				p[i]=0x00;
		}

	}
}
