/*

Obd Protocol Translator Integrated Chip v0.1.0.0
2005-2007 www.obdchip.com

PC Communication Routines

*/
#include <pic.h>
#include <stdio.h>
#include "pccom.h"
#include "global.h"

void PCputch(char c)
{

	unsigned char	dly,bitno;
	PCTxData = 0;
#ifdef __PIC16F688_H
	PC_TX_led = 0;
#endif
	bitno = 8;
	dly = PC_DELAY(TX_OHEAD);	// wait one bit time
	do
	{
	}
	while (--dly);
	do
	{
		if (c & 1)
		{
			PCTxData = 1;
		}
		if (!(c & 1))
		{
			PCTxData = 0;
		}
		c = (c >> 1) | 0x80;
		dly = PC_DELAY(TX_OHEAD);	// wait one bit time
		do
		{
		}
		while (--dly);
	}
	while (--bitno);
	PCTxData = 1;
	dly = PC_DELAY(TX_OHEAD);	// wait one bit time
	do
	{
	}
	while (--dly);
#ifdef __PIC16F688_H	
	PC_TX_led = 1;
#endif

}

char PCgetch(unsigned char echo)
{
	unsigned char	c, bitno,dly;
	for (; ;)
	{
#ifdef __PIC16F62XA_H	//code for 16F648A
		while (PCRxData)
#endif
#ifdef __PIC16F688_H	//code for 16F688
		while (!PCRxData)
#endif
		{
			continue;
		}
		dly = PC_DELAY(3) / 2;
		do
			;	// waiting in delay loop
		while (--dly);
#ifdef __PIC16F62XA_H	//code for 16F648A
		if (PCRxData)
#endif
#ifdef __PIC16F688_H	//code for 16F688
		if (!PCRxData)
#endif
		{
			continue;	// twas just noise
		}
		if (echo) PCTxData=0;
		bitno = 8;
		c = 0;
#ifdef __PIC16F688_H
		PC_RX_led=0;
#endif
		do
		{
			dly = PC_DELAY(RX_OHEAD);
			do
				;// waiting in delay loop
			while (--dly);
			if (echo) 
				{
#ifdef __PIC16F62XA_H	//code for 16F648A
					if (PCRxData)
						PCTxData=1;
					else PCTxData=0;
				}
			c = (c >> 1) | (PCRxData << 7);
#endif
#ifdef __PIC16F688_H	//code for 16F688
					if (!PCRxData)
						PCTxData=1;
					else PCTxData=0;
				}
			c = (c >> 1) | (!PCRxData << 7);
#endif
		}
		while (--bitno);
#ifdef __PIC16F688_H
		PC_RX_led=1;
#endif
		if (echo) 
		{
			dly = PC_DELAY(3)/2;
			do
				;	// waiting in delay loop
			while (--dly);

			PCTxData=1;
		}
		return c;
	}
}


void PCsend(const char* s)
{
	while (*s)
	{
		PCputch(*s++);
	}
}

void PCputcha(unsigned char kx)
{
	unsigned char c1,c2,k;
	k = kx / 16;
	if (k > 9)
		c1 = k + 55;
	else
		c1 = k + 48;
	k = kx - k * 16;
	if (k > 9)
		c2 = k + 55;
	else
		c2 = k + 48;
	PCputch(c1);
	PCputch(c2);
}

void simple_cr(unsigned char line_feed)
{
		PCputch(0x0D);
		if (line_feed)
		{
			PCputch(0x0A);
		}
}

void cr(unsigned char line_feed)
{
	if (data_style==PACKED)
	{
		/*PCputch(0x0D);
		if (line_feed)
		{
			PCputch(0x0A);
		}*/
		simple_cr(line_feed);
		PCputch(0x3E);
	}
	else
	{
		
		/*PCputch(0x0D);
		if (line_feed)
		{
			PCputch(0x0A);
		}
		PCputch(0x0D);
		if (line_feed)
		{
			PCputch(0x0A);
		}*/
		simple_cr(line_feed);
		simple_cr(line_feed);
		PCputch(0x3E);
	}
}

