/*

Obd Protocol Translator Integrated Chip v0.1.0.0
2005-2007 www.obdchip.com

PC Communications Header

*/

#include "constants.h"

/*	Don't change anything else */
#define	DLY		3		/* cycles per null loop */
#define	TX_OHEAD	13		/* overhead cycles per loop */
#define	RX_OHEAD	12		/* receiver overhead per loop */

#define	PC_DELAY(ohead)	(((PIC_CLK/4/PC_BRATE)-(ohead))/DLY)

/*	Transmit and Receive port bits */
#define PORTBIT(adr, bit) ((unsigned)(&adr)*8+(bit))

#ifdef __PIC16F688_H	//cod pentru 16F688
static bit	PCTxData 		@ PORTBIT(PORTC, 4);
static bit	PCRxData 		@ PORTBIT(PORTC, 5);
static bit	PC_TX_led 		@ PORTBIT(PORTC, 2);
static bit	PC_RX_led 		@ PORTBIT(PORTC, 3);
static bit	LF_mode 		@ PORTBIT(PORTA, 3);

static bit	TRIS_PCTxData 	@ PORTBIT(TRISC, 4);
static bit	TRIS_PCRxData 	@ PORTBIT(TRISC, 5);
static bit	TRIS_PC_TX_led	@ PORTBIT(TRISC, 2);
static bit	TRIS_PC_RX_led 	@ PORTBIT(TRISC, 3);
static bit	TRIS_LF_mode 	@ PORTBIT(TRISA, 3);
#endif

#ifdef __PIC16F62XA_H	//cod pentru 16F648A
static bit	TRIS_PCTxData 	@ PORTBIT(TRISB, 2);
static bit	TRIS_PCRxData 	@ PORTBIT(TRISB, 1);

static bit	PCTxData 		@ PORTBIT(PORTB, 2);
static bit	PCRxData 		@ PORTBIT(PORTB, 1);
#endif

//*********************************************
void PCputch(char c);
void PCputcha(unsigned char kx);
char PCgetch(unsigned char echo);
char PCgetche(void);
void PCsend(const char* s);
void cr(unsigned char line_feed);
void simple_cr(unsigned char line_feed);
void PCput_ascii(unsigned char);
